import 'package:shared_preferences/shared_preferences.dart';

/// Classe pour gérer les préférences utilisateur à l'aide de SharedPreferences.
/// Permet de stocker et récupérer des informations de manière non sécurisée,
/// contrairement au stockage sécurisé qui est utilisé pour des données sensibles.
class PreferencesHelper {
  // Initialisation de SharedPreferences en tant que Future
  final Future<SharedPreferences> _prefs = SharedPreferences.getInstance();

  /// Sauvegarde une chaîne de caractères (String) dans les préférences.
  Future<void> setString(String key, String value) async {
    print("Sauvegarde dans les préférences : clé = $key, valeur = $value");
    final prefs = await _prefs;
    await prefs.setString(key, value);
    print("Sauvegarde réussie pour la clé : $key");
  }

  /// Récupère une chaîne de caractères depuis les préférences.
  Future<String?> getString(String key) async {
    print("Récupération depuis les préférences pour la clé : $key");
    final prefs = await _prefs;
    final value = prefs.getString(key);
    print("Valeur récupérée pour la clé $key : $value");
    return value;
  }

  /// Supprime une entrée dans les préférences.
  Future<void> remove(String key) async {
    print("Suppression dans les préférences pour la clé : $key");
    final prefs = await _prefs;
    await prefs.remove(key);
    print("Suppression réussie pour la clé : $key");
  }

  /// Sauvegarde l'identifiant utilisateur dans les préférences.
  Future<void> saveUserId(String userId) async {
    print("Sauvegarde de l'userId dans les préférences : $userId");
    await setString('user_id', userId);
    print("Sauvegarde réussie de l'userId.");
  }

  /// Récupère l'identifiant utilisateur depuis les préférences.
  Future<String?> getUserId() async {
    print("Récupération de l'userId depuis les préférences.");
    return await getString('user_id');
  }

  /// Sauvegarde le nom d'utilisateur dans les préférences.
  Future<void> saveUserName(String userName) async {
    print("Sauvegarde du userName dans les préférences : $userName");
    await setString('user_name', userName);
    print("Sauvegarde réussie du userName.");
  }

  /// Récupère le nom d'utilisateur depuis les préférences.
  Future<String?> getUserName() async {
    print("Récupération du userName depuis les préférences.");
    return await getString('user_name');
  }

  /// Sauvegarde le prénom de l'utilisateur dans les préférences.
  Future<void> saveUserLastName(String userLastName) async {
    print("Sauvegarde du userLastName dans les préférences : $userLastName");
    await setString('user_last_name', userLastName);
    print("Sauvegarde réussie du userLastName.");
  }

  /// Récupère le prénom de l'utilisateur depuis les préférences.
  Future<String?> getUserLastName() async {
    print("Récupération du userLastName depuis les préférences.");
    return await getString('user_last_name');
  }

  /// Supprime toutes les informations utilisateur dans les préférences.
  Future<void> clearUserInfo() async {
    print("Suppression des informations utilisateur (userId, userName, userLastName) des préférences.");
    await remove('user_id');
    await remove('user_name');
    await remove('user_last_name');
    print("Suppression réussie des informations utilisateur.");
  }
}
